using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DragAndDropExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(568, 406);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.label1.Location = new System.Drawing.Point(0, 374);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(568, 32);
			this.label1.TabIndex = 1;
			this.label1.Text = "Drag and drop image files and text";
			// 
			// Form1
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 406);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.pictureBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.DragOver += new System.Windows.Forms.DragEventHandler(this.Form1_DragOver);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.Form1_DragDrop);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		// Decide if this form can accept the target, and if so give feedback that it can
		private void Form1_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// Check to see if the drag event contains a file data type,
			// i.e., that we are dragging a file. Ignore all other drages.
			if ( e.Data.GetDataPresent(DataFormats.FileDrop) ||
					e.Data.GetDataPresent(DataFormats.Text) )
			{
				// Change the feedback (the effect) to show that this drag is allowable
				if ((e.AllowedEffect & DragDropEffects.Move) != 0)
					e.Effect = DragDropEffects.Move;
			}	
		}

		// When a file (and only a file) is dropped onto this form, check if its in
		// image and put it into the pictureBox
		private void Form1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try 
			{	
				// If we drop a file try and load it into the image box
				if (e.Data.GetDataPresent (DataFormats.FileDrop))
				{
					// Get the file path of the file and load it
					string[] filepath = (string[]) e.Data.GetData (DataFormats.FileDrop);
					Image image = Image.FromFile (filepath[0]);
					pictureBox1.Image = image;
				} 
				// If we drop a string, try and load it to the label
				if (e.Data.GetDataPresent (DataFormats.StringFormat) )
				{
					label1.Text = (string) e.Data.GetData (DataFormats.StringFormat);
				}
			} catch (Exception exc) {}
				
		}
	}
}
